Package: DistributionUtils
Version: 0.6-2
Date: 2025-03-29
Title: Distribution Utilities
Authors@R: person(given = "David",
                  family = "Scott",
                  role = c("aut", "cre"),
                  email = "d.scott@auckland.ac.nz")
Maintainer: David Scott <d.scott@auckland.ac.nz>
Depends: R (>= 3.0.1)
Suggests: GeneralizedHyperbolic, VarianceGamma, SkewHyperbolic, RUnit
Encoding: UTF-8
Description: Utilities are provided which are of use in the
    packages I have developed for dealing with
    distributions. Currently these packages are GeneralizedHyperbolic,
    VarianceGamma, and SkewHyperbolic and NormalLaplace. Each of these
    packages requires DistributionUtils. Functionality includes sample
    skewness and kurtosis, log-histogram, tail plots, moments by
    integration, changing the point about which a moment is
    calculated, functions for testing distributions using inversion
    tests and the Massart inequality. Also includes an implementation
    of the incomplete Bessel K function.
License: GPL (>= 2)
NeedsCompilation: yes
Packaged: 2025-03-29 00:24:59 UTC; dsco0
Author: David Scott [aut, cre]
Repository: CRAN
Date/Publication: 2025-03-29 01:10:02 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-26 11:25:19 UTC; unix
Archs: DistributionUtils.so.dSYM

### Unit tests of function momChangeAbout

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make

test.momChangeAbout <- function()
{
  ## Purpose: Level 1 test of momChangeAbout
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Scott, Date:  4 Feb 2010, 14:34


  ## Gamma distribution
  k <- 4
  shape <- 2
  scale <- 1
  old <- 0
  new <- shape*scale         # central moments
  sampSize <- 10000
  x <- rgamma(sampSize, shape, scale = scale)


  ## Sample moments
  s4new <- mean((x - new)^k)
  s3new <- mean((x - new)^3)


  ## Calculate 1st to 4th raw moments
  m <- numeric(k)
  for (i in 1:k){
    m[i] <- gamma(shape + i)/gamma(shape)
  }


  ## Calculate 4th moment about new
  m4new <- momChangeAbout(k, m, old, new)
  ## Calculate 3rd about new
  m3new <- momChangeAbout(3, m, old, new)

  ## Calculate standard errors for gamma
  rawMom <- numeric(8)
  gammaMom <- function(order, shape, scale){
    gMom <- (scale^order)*gamma(shape + order)/gamma(shape)
    return(gMom)
  }
  rawMom <- sapply(1:8, gammaMom, shape = shape, scale = scale)
  centralMom <- momChangeAbout("all", rawMom, 0, rawMom[1])
  s4SE <- momSE(4, sampSize, centralMom)
  s3SE <- momSE(3, sampSize, centralMom[1:6])
  ## Compare with sample values
  s4tol <- qnorm(0.995)*s4SE
  s3tol <- qnorm(0.995)*s3SE
  checkTrue(abs(s4new - m4new) < s4tol)
  checkTrue(abs(s3new - s3new) < s3tol)

  return()
}

### Unit tests of function logHist

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make


graphicstest.logHist <- function()
{
  ## Purpose: Test the log histogram function logHist
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Scott, Date: 26 Jan 2010, 16:43

  ## open file for graphical output
  graphicsOutput <- paste(pathReport, "logHist.pdf", sep = "")
  cat("Graphics output in file ", graphicsOutput, "\n")
  pdf(file = graphicsOutput)
  print(pathReport)

  ## generate data
  x <- rgamma(200, 1)

  ## default
  logHist(x)

  ## log histogram only
  logHist(x, htype = "h")
  ## points only, some options
  logHist(x, htype = "p", pch = 20, cex = 2, col = "steelblue")

  dev.off()


  return()
}

### Unit tests of function distIneqMassart

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make

level2test.distIneqMassart <- function()
{
  ## Purpose: Level 1 test of distIneqMassart
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Scott, Date:  9 Feb 2010, 12:11

  ## Normal (default)
  checkTrue(distIneqMassart()$check)
  ## Specify parameter values of normal
  checkTrue(distIneqMassart(mean = 1, sd = 2)$check)

  ## Gamma distribution has no default value for shape
  checkTrue(distIneqMassart("gamma", shape = 1)$check)

  return()
}

### Unit tests of function is.wholenumber

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make

test.is.wholenumber <- function()
{
  ## Purpose: Level 1 test of is.wholenumber
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Local, Date: 25 Jan 2010, 16:25

  checkTrue(is.wholenumber(-3:5))
  checkTrue(!is.wholenumber(c(0,0.1,1.3,5)))
  checkTrue(is.wholenumber(-3:5 + .Machine$double.eps))
  checkTrue(!is.wholenumber(-3:5 + .Machine$double.eps^0.5))
  checkTrue(is.wholenumber(c(2L,3L)))
  checkTrue(!is.wholenumber(c("2L","3L")))
  checkTrue(!is.wholenumber(0i ^ (-3:3)))
  checkTrue(is.wholenumber(matrix(1:6, nrow = 3)))
  checkTrue(!is.wholenumber(list(-1:3,2:6)))
  checkTrue(!is.numeric(list(-1:3,2:6)))
  checkTrue(is.wholenumber(unlist(list(-1:3,2:6))))

  return()
}

### Unit tests of function tsHessian

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make

test.tsHessian <- function()
{
  ## Purpose: Level 1 test of tsHessian
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Scott, Date: 12 May 2010, 19:36

  ## Consider Hessian of log(1 + x + 2y)
  ## Example from Lang: A Second Course in Calculus, p.74
  fun <- function(param){
    x <- param[1]
    y <- param[2]
    return(log(1 + x + 2*y))
  }

  ## True value of Hessian
  trueHessian <- matrix( c(-1,-2,
                           -2,-4), byrow = 2, nrow = 2)
  

  ## Value from tsHessian
  approxHessian <- tsHessian(c(0,0), fun = fun)
  maxDiff <- max(abs(trueHessian - approxHessian))
  checkTrue(maxDiff < 0.1)

  return()
}

### Unit tests of functions tailPlot, normTailPlotLine, tTailPlotLine
### and gammaTailPlotLine

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make


graphicstest.tailPlot <- function()
{
    ## Purpose: Test the tail plot functions
    ## ----------------------------------------------------------------------
    ## Arguments:
    ## ----------------------------------------------------------------------
    ## Author: David Scott, Date: 10 Mar 2010, 21:00

    ## open file for graphical output
    graphicsOutput <- paste(pathReport, "tailPlot.pdf", sep = "")
    cat("Graphics output in file ", graphicsOutput, "\n")
    pdf(file = graphicsOutput)
    print(pathReport)

    ## Draw tail plot of some data
    x <- rnorm(100, 1, 2)
    tailPlot(x)
    ## Add normal distribution line
    normTailPlotLine(x, mean = 1, sd = 2)
    ## Add t distribution line
    tTailPlotLine(x, df = 5, lty = 2)
    ## Use fitted values
    normTailPlotLine(x, mean = mean(x), sd = sd(x), lty = 3)

    ## Gamma distribution
    x <- rgamma(100, shape = 1, scale = 1)
    tailPlot(x)
    ## Add gamma distribution line
    gammaTailPlotLine(x, shape = 1, scale = 1)
    ## Left tail example
    tailPlot(x, side = "l")
    ## Add gamma distribution line
    gammaTailPlotLine(x, shape = 1, scale = 1, side = "l")
    ## Log scale on both axes
    tailPlot(x, side = "l", log = "xy")
    ## Add gamma distribution line
    gammaTailPlotLine(x, shape = 1, scale = 1, side = "l")


    ## Add line from a standard distribution with default parameters
    x <- rlnorm(100)
    tailPlot(x)
    tailPlotLine(x, distrFn = "lnorm")

    ## Add line from a distribution with 'param' argument
    require(VarianceGamma)
    param <- c(0,0.5,0,0.5)
    x <- rvg(100, param = param)
    tailPlot(x)
    tailPlotLine(x, distrFn = "vg", param = param)
    dev.off()


    return()
}

### Unit tests of function safeIntegrate

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make

test.safeIntegrate <- function()
{
  ## Purpose: Level 1 test of safeIntegrate
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Local, Date: 03 Feb 2010, 16:25

  checkEquals(safeIntegrate(dnorm, -1.96, 1.96)$value,
              0.9500042097036, tolerance = 1.0e-11)
  checkEquals(safeIntegrate(dnorm, 1.96, 1.96)$value,
              0, tolerance = 1.0e-11)
  checkEquals(safeIntegrate(dnorm, -Inf, Inf)$value,
              0.9999999997942, tolerance = 1.0e-11)
  checkEquals(safeIntegrate(dnorm, -Inf, -Inf)$value,
              0, tolerance = 1.0e-11)
  checkEquals(safeIntegrate(dnorm, Inf, Inf)$value,
              0, tolerance = 1.0e-11)
  return()
}

### Unit tests of function integrateDens

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make

test.integrateDens <- function()
{
  ## Purpose: Level 1 test of integrateDens
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Scott, Date: 08 Feb 2010, 21:07

  ## Normal (default)
  totPr <- integrateDens()$value
  checkEquals(totPr, 1)
  totPr <- integrateDens("norm", mean = 3, sd = 2)$value
  checkEquals(totPr, 1)
  half <- integrateDens("norm", lower = 3, mean = 3, sd = 2)$value
  checkEquals(half, 1/2)

  ## t
  totPr <- integrateDens("t", df = 4)$value
  checkEquals(totPr, 1)
  half <- integrateDens("t", lower = 0, df = 4)$value
  checkEquals(half, 1/2)

  ## Weibull
  totPr <- integrateDens("weibull", shape = 1)
  checkEquals(half, 1/2)

  return()
}

### Unit tests of function besselRatio

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make

test.besselRatio <- function()
{
  ## Purpose: Level 1 test of besselRatio
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Local, Date: 25 Jan 2010, 14:17

  nus <- c(0:5, 10, 20)
  x <- seq(1, 4, length.out = 11)
  k <- 3

  ## check calculation of ratios agrees with calculation via besselK
  bK <- matrix(nrow = length(nus), ncol = length(x))
  bRatio <- matrix(nrow = length(nus), ncol = length(x))
  compare <- matrix(nrow = length(nus), ncol = length(x))
  unitMatrix <- matrix(1, nrow = length(nus), ncol = length(x))
  
  for (i in 1:length(nus)){
    for (j in 1:length(x)) {
      bK[i,j] <- besselK(x[j], nus[i] + k)/besselK(x[j], nus[i])
      bRatio[i,j] <- besselRatio(x[j], nus[i],
                                 orderDiff = k)

      compare[i,j] <- bK[i,j]/bRatio[i,j]
    }
  }

  checkEquals(compare, unitMatrix)  

  ## check exponential scaling works properly
  raw <- matrix(nrow = length(nus), ncol = length(x))
  scaled <- matrix(nrow = length(nus), ncol = length(x))
  compare <- matrix(nrow = length(nus), ncol = length(x))
  unitMatrix <- matrix(1, nrow = length(nus), ncol = length(x))

  for (i in 1:length(nus)){
    for (j in 1:length(x)) {
      raw[i,j] <- besselRatio(x[j], nus[i],
                              orderDiff = k)
      scaled[i,j] <- besselRatio(x[j], nus[i],
                                 orderDiff = k, useExpScaled = 1)
      compare[i,j] <- raw[i,j]/scaled[i,j]
    }
  }

  checkEquals(compare, unitMatrix) 

  return()
}

### Unit tests of function momSE

### Functions with name test.* are run by R CMD check or by make if
### LEVEL=1 in call to make
### Functions with name levelntest.* are run by make if
### LEVEL=n in call to make
### Functions with name graphicstest.* are run by make if
### LEVEL=graphics in call to make

test.momSE <- function()
{
  ## Purpose: Level 1 test of momSE
  ## ----------------------------------------------------------------------
  ## Arguments:
  ## ----------------------------------------------------------------------
  ## Author: David Scott, Date: 5 Feb 2010, 11:53

  ## Moments of the normal distribution, mean 1, variance 4
  mu <- 1
  sigma <- 2
  n <- 100
  mom <- c(0,sigma^2,0,3*sigma^4,0,15*sigma^6,0,105*sigma^8)
  ## standard error of sample variance
  checkEquals(momSE(2, 100, mom[1:4]), sqrt(2*sigma^4/n))

  ## standard error of sample central third moment
  checkEquals(momSE(3, 100, mom[1:6]), sqrt(6*sigma^6/n))

  ## standard error of sample central fourth moment
  checkEquals(momSE(4, 100, mom), sqrt(96*sigma^8/n))

  ## Moments of the gamma distribution, shape 1, scale 2
  shape <- 1
  scale <- 2
  n <- 1000
  rawMom <- numeric(8)
  gammaMom <- function(order, shape, scale){
    gMom <- (scale^order)*gamma(shape + order)/gamma(shape)
    return(gMom)
  }
  rawMom <- sapply(1:8, gammaMom, shape = shape, scale = scale)
  centralMom <- momChangeAbout("all", rawMom, 0, rawMom[1])

  stErrors <- numeric(4)
  stErrors[1] <- sqrt(centralMom[2]/n)
  for (i in (2:4)){
    stErrors[i] <- momSE(i, n, centralMom[1:(2*i)])
  }
  stErrors
  shouldBe <- c(0.06324555320337,0.35777087639997,
                3.71806401235912,60.10550723519435)


  ## compare with previously calculated answer
  checkEqualsNumeric(stErrors, shouldBe)



  return()
}
